VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTaskList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' *************************************************************************
'  Copyright 1998-2000 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

Private Declare Function GetTopWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetNextWindow Lib "user32" Alias "GetWindow" (ByVal hwnd As Long, ByVal wFlag As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetClassname Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassname As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" (ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, lParam As Any, ByVal fuFlags As Long, ByVal uTimeout As Long, lpdwResult As Long) As Long
Private Declare Function IsIconic Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function LoadIcon Lib "user32" Alias "LoadIconA" (ByVal hInstance As Long, lpIconName As Any) As Long

Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function BringWindowToTop Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal dwFlags As Long, ByVal th32ProcessID As Long) As Long
Private Declare Function Process32First Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Boolean
Private Declare Function Process32Next Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Boolean

Private Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function ShowOwnedPopups Lib "user32" (ByVal hwnd As Long, ByVal fShow As Long) As Long

Private Const GW_HWNDFIRST = 0
Private Const GW_HWNDNEXT = 2

Private Const GWL_STYLE = (-16)
Private Const GWL_EXSTYLE = (-20)
Private Const GWL_HWNDPARENT = (-8)
Private Const WS_EX_TOOLWINDOW = &H80

Private Const WM_NULL = &H0
Private Const WM_GETTEXT = &HD
Private Const WM_GETTEXTLENGTH = &HE
Private Const WM_CLOSE = &H10
Private Const WM_QUIT = &H12

Private Const SMTO_NORMAL = &H0
Private Const SMTO_BLOCK = &H1
Private Const SMTO_ABORTIFHUNG = &H2

Private Const SW_HIDE = 0
Private Const SW_SHOWNORMAL = 1
Private Const SW_NORMAL = 1
Private Const SW_SHOWMINIMIZED = 2
Private Const SW_SHOWMAXIMIZED = 3
Private Const SW_MAXIMIZE = 3
Private Const SW_SHOWNOACTIVATE = 4
Private Const SW_SHOW = 5
Private Const SW_MINIMIZE = 6
Private Const SW_SHOWMINNOACTIVE = 7
Private Const SW_SHOWNA = 8
Private Const SW_RESTORE = 9
Private Const SW_SHOWDEFAULT = 10
Private Const SW_FORCEMINIMIZE = 11
Private Const SW_MAX = 11

Private Const IDI_WINLOGO = 32517&
Private Const IDI_APPLICATION = 32512&

Private Const ERROR_TIMEOUT = 1460

' Private storage for class data
Private Type TaskListItems
   hwnd As Long
   Caption As String
End Type

Private Type PROCESSENTRY32
   dwSize As Long
   cntUsage As Long
   th32ProcessID As Long
   th32DefaultHeapID As Long
   th32ModuleID As Long
   cntThreads As Long
   th32ParentProcessID  As Long
   pcPriClassBase  As Long
   dwFlags  As Long
   szExeFile As String
End Type

Private m_CASEsens As Boolean
Private m_FindStr As String
Private m_Count As Long
Private m_tasks() As TaskListItems
Private m_Mode As TaskListModes
Private m_HungTimeout As Long

Private Const defHungTimeout = 500 'milliseconds
Private Const ArrayBump = 20

Private IsNT As Boolean

' Operating modes:
Public Enum TaskListModes
   tlAltTab = 0
   tlTaskMgr = 1
End Enum

' Status values:
Public Enum TaskStatus
   tlStatusOK = 0
   tlStatusHung = 1
End Enum
   
' ************************************************
'  Initialize/Terminate
' ************************************************
Private Sub Class_Initialize()
    ' Assign default class properties
    m_Mode = tlAltTab
    ' Set default timeout for "hung" tasks
    m_HungTimeout = defHungTimeout
    ' Initialize cache array
    ReDim m_tasks(0 To ArrayBump - 1) As TaskListItems
    
    Dim dw As Long, c As Integer, iWinMajor As Integer, iWinMinor As Integer
    dw = GetVersion()
    iWinMajor = dw And &HFF&
    iWinMinor = (dw And &HFF00&) / &H100&
'    Dim sMode
'    Dim sys
'    sMode = IIf(dw And &H80000000, "Windows 95", "Windows NT")
'    GetSystemInfo sys

End Sub

Private Sub Class_Terminate()
   '
End Sub

' ************************************************
'  Public Properties (Read/Write)
' ************************************************
Public Property Let HungTimeout(ByVal NewVal As Long)
   ' Set new timeout period to consider
   ' a task "hung".
   If NewVal > 0 Then
      m_HungTimeout = NewVal
   End If
End Property

Public Property Get HungTimeout() As Long
   HungTimeout = m_HungTimeout
End Property

Public Property Let FindStr(ByVal NewStr As String)
    m_FindStr = NewStr
End Property

Public Property Get FindStr() As String
   FindStr = m_FindStr
End Property

Public Property Let Mode(ByVal NewVal As TaskListModes)
   Select Case NewVal
      Case tlAltTab, tlTaskMgr
         m_Mode = NewVal
      Case Else
         ' Potentially raise an error, or
         ' just ignore bad input.
   End Select
End Property

Public Property Get Mode() As TaskListModes
   Mode = m_Mode
End Property

' ************************************************
'  Public Properties (Read-Only)
' ************************************************
Public Property Get Caption(ByVal Index As Long) As String
   If Index > 0 And Index <= m_Count Then
      ' Return associated caption.
      Caption = m_tasks(Index - 1).Caption
   End If
End Property

Public Property Let CASEsens(ByVal NewVal As Boolean)
    m_CASEsens = NewVal
End Property
'
Public Property Get CASEsens() As Boolean
   CASEsens = m_CASEsens
End Property

Public Property Get Count() As Long
   ' Return task count.
   Count = m_Count
End Property

Public Property Get hwnd(ByVal Index As Long) As Long
   If Index > 0 And Index <= m_Count Then
      ' Return handle of top-level window.
      hwnd = m_tasks(Index - 1).hwnd
   End If
End Property

Public Property Get Status(ByVal Index As Long) As TaskStatus
   Static nRet As Long
   Static lpdwResult As Long
   Const Flags As Long = SMTO_ABORTIFHUNG 'Or SMTO_BLOCK
   ' Detection of "hung" status based on KB article Q231844:
   ' http://support.microsoft.com/support/kb/articles/Q231/8/44.ASP
   If Index > 0 And Index <= m_Count Then
      ' Assume task is not hung.
      Status = tlStatusOK
      ' See if task responds to null msg.
      nRet = SendMessageTimeout(m_tasks(Index - 1).hwnd, WM_NULL, 0&, 0&, Flags, m_HungTimeout, lpdwResult)
      If nRet = 0 Then
         ' In NT, Err.LastDllError will be
         ' set to ERROR_TIMEOUT, but we can't
         ' count on that in Win9x.
         Status = tlStatusHung
      End If
   End If
End Property

Public Function Kill(ByVal Index As Long) As Boolean
    Static lpdwResult As Long
    Const Flags As Long = SMTO_BLOCK 'Or SMTO_BLOCK
    'WM_CLOSE or WM_QUIT
    Kill = SendMessageTimeout(m_tasks(Index - 1).hwnd, _
             WM_CLOSE, 0&, 0&, Flags, m_HungTimeout, lpdwResult)
End Function

Public Property Get Valid(Optional ByVal Index As Long, Optional ByVal hwnd As Long) As Boolean
   Dim i As Long
   
   ' If passed an hWnd, find index within tasklist.
   If hwnd <> 0 Then
      For i = 0 To m_Count - 1
         If m_tasks(i).hwnd = hwnd Then
            Index = i + 1
            Exit For
         End If
      Next i
   End If
   
   ' Check to see if window still exists.
   If Index > 0 And Index <= m_Count Then
      If IsTask(m_tasks(Index - 1).hwnd) Then
         Valid = True
      Else
         ' Delete that pup!
         m_tasks(Index - 1).hwnd = 0
         m_Count = CompactCache()
         Valid = False
      End If
   End If
End Property

' ************************************************
'  Public Methods
' ************************************************
Public Sub Minimize(Optional ByVal Index As Long, Optional ByVal hwnd As Long)
   Dim ret As Long
   Dim i As Long
   ' If passed an hWnd, find index within tasklist.
   If hwnd <> 0 Then
      For i = 0 To m_Count - 1
         If m_tasks(i).hwnd = hwnd Then
            Index = i + 1
            Exit For
         End If
      Next i
   End If
   
   ' If we have a valid Index, try to activate.
   If Index > 0 And Index <= m_Count Then
      With m_tasks(Index - 1)
         'If Len(.Caption) Then
            ret = ShowWindow(.hwnd, SW_MINIMIZE)
         'End If
      End With
   End If
End Sub

Public Sub Activate(Optional ByVal Index As Long, Optional ByVal hwnd As Long)
   Dim ret As Long
   Dim i As Long
   
   ' If passed an hWnd, find index within tasklist.
   If hwnd <> 0 Then
      For i = 0 To m_Count - 1
         If m_tasks(i).hwnd = hwnd Then
            Index = i + 1
            Exit For
         End If
      Next i
   End If
   
   ' If we have a valid Index, try to activate.
   If Index > 0 And Index <= m_Count Then
      With m_tasks(Index - 1)
         If Len(.Caption) Then
            If IsIconic(.hwnd) Then
               ret = ShowWindow(.hwnd, SW_SHOW)
               'ret = ShowWindow(.hwnd, SW_SHOW)
            End If
            'ret = BringWindowToTop(.hwnd)
            ret = SetForegroundWindow(.hwnd)
            ret = (GetForegroundWindow = .hwnd)
            'ret = ShowOwnedPopups(.hwnd, True)

            ' new
            'ret = SetActiveWindow(.hwnd)
         End If
      End With
   End If
End Sub

Public Sub Refresh()
   Dim i As Long
   Dim hwnd As Long

   ' Flag tasks no longer running
   ' as overwriteable.
   For i = 0 To m_Count - 1
      If IsWindow(m_tasks(i).hwnd) = 0 Then
         m_tasks(i).hwnd = 0
      End If
   Next i
   
   ' Clean up wasted space in cache.
   m_Count = CompactCache()
   
   ' Loop through window list and add
   ' any/all new tasks.
   hwnd = GetTopWindow(0)
   Do While hwnd
      ' Determine if this meets task criteria.
      
      If m_Mode = tlAltTab Then
        If IsTask(hwnd) Then _
            Call AddTask(hwnd)
      Else
            Call AddTask(hwnd)
      End If
      Sleep (0)
      ' Get next window and move on.
      hwnd = GetNextWindow(hwnd, GW_HWNDNEXT)
   Loop
End Sub

' ************************************************
'  Private Methods
' ************************************************
Private Sub AddTask(ByVal hwnd As Long)
    Dim Caption As String, Caption2 As String
    Dim nIndex As Long
    Dim hWndParent As Long
    Dim lpdwResult As Long
    Dim nLen As Long
    Dim nRet As Long
    Dim i As Long
    Const Flags As Long = SMTO_ABORTIFHUNG ' Or SMTO_BLOCK
    
    ' Check if this task is already cached, and
    ' if so store the array Index for future use.
    For i = 0 To m_Count - 1
       If hwnd = m_tasks(i).hwnd Then
          nIndex = i + 1
          Exit For
       End If
    Next i
    
    ' Get length of Caption using SendMessageTimeout
    ' which will return even if app is "hung".
    nRet = SendMessageTimeout(hwnd, WM_GETTEXTLENGTH, 0&, ByVal 0&, Flags, m_HungTimeout, lpdwResult)
    
    ' Check if app is hung, and if so bail
    ' if this task is already cached.
    If nRet = 0 Then
       ' In NT, Err.LastDllError will be
       ' set to ERROR_TIMEOUT, but we can't
       ' count on that in Win9x.
       Debug.Print "Timeout on &h" & Hex(hwnd)
       If nIndex Then Exit Sub
    Else
       ' Caption length returned in lpdwResult,
       ' if app isn't hung.
       nLen = lpdwResult + 1
    End If
    
     ' Retrieve full Caption.
     Caption = String$(nLen, 0)
     nRet = SendMessageTimeout(hwnd, WM_GETTEXT, nLen, ByVal Caption, Flags, m_HungTimeout, lpdwResult)
     If nRet Then
        nLen = lpdwResult
        
        ' If window is owned, then take owner.
        hWndParent = GetWindowLong(hwnd, GWL_HWNDPARENT)
        If hWndParent = 0 Then hWndParent = hwnd

       ' Only tasks with a Caption qualify
       ' for addition to cached task array.
       If nLen > 1 Then 'And IsTask(hWnd) Then
         If m_CASEsens Then nRet = InStr(1, Caption, m_FindStr) _
         Else: nRet = InStr(1, LCase(Caption), LCase(m_FindStr))
         
         If nRet <> 0 Then
            ' bingo
            
            ' Resize array if no more empty slots.
            If m_Count > UBound(m_tasks) Then
               ReDim Preserve m_tasks(0 To UBound(m_tasks) + ArrayBump) As TaskListItems
            End If
            
            ' Use existing index if task is already
            ' cached, otherwise place at next available
            ' slot in array.
            If nIndex Then
               ' Shift to 0-based index.
               nIndex = nIndex - 1
            Else
               nIndex = m_Count
               ' Bump stored count of tasks.
               m_Count = m_Count + 1
            End If
                
            'WM_NULL = &H0
            'WM_GETTEXT = &HD
            'WM_GETTEXTLENGTH = &HE
            'nRet = SendMessageTimeout(hWnd, WM_GETTEXTLENGTH, 0&, ByVal 0&, flags, m_HungTimeout, lpdwResult)
            
            ' retrieve other things from childwindows
'            Caption2 = String$(255, 0)
'            nLen = GetWindowText(hWnd, Caption2, 256)
'            If nLen <> 0 Then
'                Caption2 = Left$(Caption2, nLen)
'            End If
            
            ' Cache data associated with window.
            m_tasks(nIndex).hwnd = hwnd
            m_tasks(nIndex).Caption = Left$(Caption, nLen)
         End If
       Else
            'm_tasks(nIndex).Caption = "<no title>"
       End If
    End If
End Sub

Private Function Classname(ByVal hwnd As Long) As String
   Dim nRet As Long
   Dim Class As String
   Const MaxLen As Long = 256
   
   ' Retrieve classname of passed window.
   Class = String$(MaxLen, 0)
   nRet = GetClassname(hwnd, Class, MaxLen)
   If nRet Then Classname = Left$(Class, nRet)
End Function

Private Function CompactCache() As Long
   Dim i As Long, j As Long
   
   ' Compact cached window array.
   If m_Count Then
      For i = 0 To UBound(m_tasks) - 1
         If m_tasks(i).hwnd = 0 Then
            For j = i To UBound(m_tasks) - 1
               m_tasks(j).hwnd = m_tasks(j + 1).hwnd
               m_tasks(j).Caption = m_tasks(j + 1).Caption
            Next j
         End If
      Next i
   End If
   
   ' Get count of cached tasks.
   For i = 0 To UBound(m_tasks)
      If m_tasks(i).hwnd = 0 Then
         CompactCache = i
         Exit For
      End If
   Next i
End Function

Private Function IsTask(ByVal hwnd As Long) As Boolean
   Dim hwndOwner As Long
   
   Select Case m_Mode
      ' Special thanks to Jonathan Wood <http://www.softcircuits.com>
      ' for pointing out that the Alt+Tab order is the same as returned
      ' by a GetWindow loop.
      Case tlAltTab
         ' Must be visible.
         If IsWindowVisible(hwnd) Then
            ' Can't have Parent.
            If GetParent(hwnd) = 0 Then
               ' Can't have Owner *except* in the case where
               ' owner has WS_EX_TOOLWINDOW StyleEx bit set.
               ' This is how VB apps (and others?) operate.
               hwndOwner = GetWindowLong(hwnd, GWL_HWNDPARENT)
               If (hwndOwner = 0) Or IsToolWindow(hwndOwner) Then
                  ' Must not be Toolwindow.
                  If Not IsToolWindow(hwnd) Then
                     ' We have a winner!
                     IsTask = True
                  End If
               End If
            End If
         End If
      
      ' Apply TaskMgr tests to passed window:
      Case tlTaskMgr
         ' Must be visible.
         If IsWindowVisible(hwnd) Then
            ' Can't have Parent.
            If GetParent(hwnd) = 0 Then
               ' And, finally, it shouldn't have an owner.
               If GetWindowLong(hwnd, GWL_HWNDPARENT) = 0 Then
                  ' TaskMgr shows all ToolWindows
                  ' *except* Program Manager.
                  If IsToolWindow(hwnd) Then
                     If Classname(hwnd) <> "Progman" Then
                        ' We have a winner!
                        IsTask = True
                     End If
                  Else
                     ' We have a winner!
                     IsTask = True
                  End If
               End If
            End If
         End If
   End Select
End Function

Private Function IsToolWindow(ByVal hwnd As Long) As Boolean
   ' Check for toolwindow style bit.
   IsToolWindow = ((GetWindowLong(hwnd, GWL_EXSTYLE) And WS_EX_TOOLWINDOW) = WS_EX_TOOLWINDOW)
End Function

Function ExePathFromProcID(idProc As Long) As String
    If Not IsNT Then
        Dim process As PROCESSENTRY32, hSnap As Long, f As Long
        hSnap = CreateToolhelp32Snapshot(Hex(2), 0)
        If hSnap = 0 Then Exit Function
        process.dwSize = Len(process)
        f = Process32First(hSnap, process)
        Do While f
            If process.th32ProcessID = idProc Then
                ExePathFromProcID = StrZToStr(process.szExeFile)
                Exit Function
            End If
            f = Process32Next(hSnap, process)
        Loop
    Else
        Dim s As String, c As Long
        s = String$(255, 0)
        'c = GetModuleFileNameEx(ProcFromProcID(idProc), _
            ModFromProcID(idProc), s, cMaxPath)
        If c Then ExePathFromProcID = Left$(s, c)
    End If
End Function

Function StrZToStr(s As String) As String
    Dim i As Integer
    i = InStr(s, vbNullChar)
    If i Then
        StrZToStr = Left$(s, InStr(s, vbNullChar) - 1)
    Else
        StrZToStr = s
    End If
End Function

'Function ProcFromProcID(idProc As Long)
'    ProcFromProcID = OpenProcess(PROCESS_QUERY_INFORMATION Or _
'                             PROCESS_VM_READ, 0, idProc)
'End Function
'
'Property Get WinMajor() As Integer
'    WinMajor = iWinMajor
'End Property
